//---------------------------------------------------------------------------

#ifndef ColorsH
#define ColorsH
//---------------------------------------------------------------------------
class TColors
{
private:
public:
        TColors();
        ~TColors();
/*
        void RGBtoHSV(unsigned char r,unsigned char g,unsigned char b,
                      unsigned char &h,unsigned char &s,unsigned char &v);
        void HSVtoRGB(unsigned char h,unsigned char s,unsigned char v,
                      unsigned char &r,unsigned char &g,unsigned char &b);
*/
        int             Total;

        TStringList*    Name;

        unsigned char*  r;
        unsigned char*  g;
        unsigned char*  b;

        unsigned char*  h;
        unsigned char*  s;
        unsigned char*  v;

};

//RGBHSV
void RGBtoHSV(
unsigned char r,unsigned char g,unsigned char b,
unsigned char &h,unsigned char &s,unsigned char &v)
{

        int i,j;
        unsigned char m;
        unsigned char e[3];
        unsigned char id[3];
        e[0] = r;
        e[1] = g;
        e[2] = b;
        for(i=0; i<3; i++) id[i] = i;

        for(i=1; i<3; i++){
                for(j=0; j<i; j++){
                        if(e[i-j] > e[i-j-1]){
                                m = e[i-j];
                                e[i-j] = e[i-j-1];
                                e[i-j-1] = m;
                                m = id[i-j];
                                id[i-j] = id[i-j-1];
                                id[i-j-1] = m;
                        } else break;
                }
        }

        if(e[0] == 0){
                h = 0;
                s = 0;
                v = 0;
                return;
        }

        v = e[0];

        s = 255-e[2]*255/e[0];
        if(s == 0){
                h = 0;
                return;
        }

        if((id[0]-id[1]+2)%2 == 0){
                if(id[0]-id[1]>0) i = 1; else i = -1;
        } else {
                if(id[0]-id[1]<0) i = 1; else i = -1;
        }
        h = ((512*id[0] + i*(e[1]-e[2])*255/(e[0]-e[2]) +1536) % 1536)/6;

}

//HSVRGB
void HSVtoRGB(
unsigned char h,unsigned char s,unsigned char v,
unsigned char &r,unsigned char &g,unsigned char &b)
{

        int i;
        unsigned char e[3];
        unsigned char id[3];

        e[0] = v;
        e[2] = (255-s)*v/255;
        e[1] = e[2]+(e[0]-e[2])*abs((h*6+256)%512-256)/255;

        for(i=0; i<3; i++) id[i] = abs(256*3-(h*6+256*(3+i*2))%1536)/256;

        r = e[id[0]];
        g = e[id[1]];
        b = e[id[2]];

}
#endif

