/*
	easy Tangram editor 2.13b
		for Borland C++ Builder 5
		Copyright aX,2002-2003
*/

#include <vcl.h>
#pragma hdrstop

//libpngCu[̎gp
#define PNG_SETJMP_NOT_SUPPORTED
#define Z_PREFIX
#include "png.h"
//

#include "Main.h"
#include "About.h"
#include "Color.h"
#include "Rpcal.h"
#include "ActiveViewer.h"
#include "math.h"
#include "clipbrd.hpp"
#include "inifiles.hpp"
#include "Filectrl.hpp"

#pragma package(smart_init)
#pragma resource "*.dfm"

TeTeForm *eTeForm;

__fastcall TeTeForm::TeTeForm(TComponent* Owner)
        : TForm(Owner)
{

}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ y{VXez

/*********
 ݒ
*********/
void __fastcall TeTeForm::FormCreate(TObject *Sender)
{

        int i,j;
        randomize();

        //CLoX̐ݒ
        buf1 = new Graphics::TBitmap();
        buf1->PixelFormat = pf24bit;
        buf1->Width = 512;
        buf1->Height = 512;

        //KChLoX̐ݒ
        buf2 = new Graphics::TBitmap();
        buf2->PixelFormat = pf24bit;
        buf2->Width = 128;
        buf2->Height = 128;

        //V^ONXIuWFNg̍쐬
        Tan = new Tangram();

        //INIt@C̓ǂݍ
        //----------------------
        AnsiString inidir;
        TColor bgcolor;
        bool aadown;
        bool opttbv;
        TIniFile *ini;
        ini = new TIniFile(ExtractFilePath(Application->ExeName)+"eTe.ini");
        dcxsmin   =  ini->ReadInteger("VXe","dcxsmin",    32);
        dcxabsmax =  ini->ReadInteger("VXe","dcxabsmax", 200);
        flipsens  =  ini->ReadInteger("VXe","flipsens",    8);
        fssens    =  ini->ReadInteger("VXe","fssens",      5);
        inidir    =  ini->ReadString("VXe","inidir",
                        ExtractFilePath(Application->ExeName) + "etes");
        aadown    =  (bool)ini->ReadInteger("VXe","aadown", (int)true);
        gamma     =  ini->ReadFloat("VXe","gamma",       2.2);
        opttbv    =  (bool)ini->ReadInteger("VXe","opttbv", (int)true);
        maxundo   =  ini->ReadInteger("VXe","maxundo",   100);
        if(maxundo<2) maxundo = 2;

        for(i=0; i<maxhisfiles; i++)
        OpenFileHistory[i] = ini->ReadString("qXg[",IntToStr(i).c_str(),"");

        ho      =  ini->ReadInteger("pbg","ho",      255);
        hr      =  ini->ReadInteger("pbg","hr",        0);
        so      =  ini->ReadInteger("pbg","so",        0);
        sr      =  ini->ReadInteger("pbg","sr",        0);
        vo      =  ini->ReadInteger("pbg","vo",      255);
        vr      =  ini->ReadInteger("pbg","vr",        0);
        bgcolor =  (TColor)ini->ReadInteger("pbg","bgcolor",       0);
        ho_      =  ini->ReadInteger("pbg","ho_",      255);
        hr_      =  ini->ReadInteger("pbg","hr_",        0);
        so_      =  ini->ReadInteger("pbg","so_",      255);
        sr_      =  ini->ReadInteger("pbg","sr_",        0);
        vo_      =  ini->ReadInteger("pbg","vo_",      255);
        vr_      =  ini->ReadInteger("pbg","vr_",        0);
        bgcolor_ =  (TColor)ini->ReadInteger("pbg","bgcolor_",       0);

        top     =  ini->ReadInteger("|WV","top",
                        Screen->DesktopTop + (Screen->DesktopHeight-657)/2);
        left    =  ini->ReadInteger("|WV","left",
                        Screen->DesktopLeft + (Screen->DesktopWidth-689)/2);
        height  =  ini->ReadInteger("|WV","height",  664);
        width   =  ini->ReadInteger("|WV","width",   698);
        sbx     =  ini->ReadInteger("|WV","sbx",     128);
        sby     =  ini->ReadInteger("|WV","sby",     128);
        sbz     =  ini->ReadInteger("|WV","sbz",      20);
        state   =  ini->ReadInteger("EBhE","ws", wsNormal);
        delete ini;

        //t@C̃Zbg
        for(i=0; i<maxhisfiles; i++){
                HisMenuItem[i] = new TMenuItem(this);
                HisMenuItem[i]->OnClick = HisFileOpenExecute;
                HisMenuItem[i]->Tag = i;
                PopupMenuHis->Items->Add(HisMenuItem[i]);
        }
        SetHistory();

        //AhDobt@̊m
        if((UndoBank = (TPcs *)malloc(sizeof(TPcs) * maxundo)) == NULL)
                ShortOfMemory();

        //flip sens.̐ݒ
        flipsensComboBox->Text = IntToStr(flipsens);

        //AAXCb`̐ݒ
        ToolButtonOptAA->Down = aadown;
        AA->Checked = aadown;

        //IvVc[o[̐ݒ
        OptToolBar->Visible = opttbv;

        //pbg̐ݒ
        CSet(bgcolor, ho,so,vo, hr,sr,vr);

        //fBNg̐ݒ
        //eteI[v_CAȌtH_etes
        if(! DirectoryExists(inidir)) inidir = ExtractFilePath(Application->ExeName);
        OpenDialog->InitialDir = inidir;

        //pltI[v_CAȌtH_pltes
        inidir = ExtractFilePath(Application->ExeName) + "pltes";
        if(! DirectoryExists(inidir)) inidir = ExtractFilePath(Application->ExeName);
        OpenDialogPlt->InitialDir = inidir;
        //----------------------


        //
        //pltestH_pltt@Cs[XZbg̕ύXhbv_Ej[ɓo^
        pltFiles = 0;
        TSearchRec sr;
        TStringList* pltName = new TStringList();
        pltName->Clear();
        pltName->Sorted = true;
        pltFilename = new TStringList();
        pltFilename->Clear();
        int pltIndex;

        if(FindFirst( OpenDialogPlt->InitialDir + "\\*.plt",
                        faArchive | faReadOnly | faHidden, sr) == 0){
                do{
                        pltFiles ++;
                        Tan->PltLoad(ChangeFileExt(ExtractFileName(sr.Name),""));
                        pltIndex = pltName->Add(Tan->Plt.Caption);
                        pltFilename->Insert(pltIndex, Tan->Plt.Name);
                } while (FindNext(sr) == 0);
                FindClose(sr);
        }

        pltMenuItem = (TMenuItem **)malloc(sizeof(TMenuItem *) * pltFiles);
        for(i=0; i<pltFiles; i++){
                pltMenuItem[i] = new TMenuItem(this);
                pltMenuItem[i]->OnClick = PltSLoadExecute;
                pltMenuItem[i]->Tag = i;
                pltMenuItem[i]->Caption = pltName->Strings[i];
                PopupMenuPlt->Items->Add(pltMenuItem[i]);
        }

        delete  pltName;
        Tan->SetDefault();
        Tan->NewPcs();



        //hbOhbvꂽt@CJ
        if(ParamCount() == 1){
                Tan->eTeLoad(ParamStr(1));
                if(!Tan->ErrorFlag){

                        mkListNum(0,Tan->PcsTotal);

                        PushHistory();

                        if(Tan->PcsTotal > 0){
                                Tan->PcsSelect(0);
                                List->ItemIndex  = 0;
                        }
                }
        }
        //Tan->GetBmp(-1,1.,buf1,false);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,true);
        Tan->PopPcs(Pcs2);

        ResetUndo();
        EditButtons();

        pb1ActLevel = 0;
        RectSelect = false;
        RectExists = false;

        DrawBar();

        Top = top;
        Left = left;
        Height = height;
        Width = width;
        WindowState = (TWindowState)state;

}


/*********************
 LoX̕`
*********************/
void __fastcall TeTeForm::FormPaint(TObject *Sender)
{
        ReDraw(true,true);

}

void __fastcall TeTeForm::FormResize(TObject *Sender)
{

        int dx=0,dy=0;
        int ix=-2,iy=-32;
        if(Height>666) dy = (Height-666)/2;
        if(Width>689) dx = (Width-689)/2;

        Bevel1->Top = 63+dy+iy;
        Bevel1->Left = 152+dx+ix;

        Shape1->Top = 37+dy+iy;
        Shape1->Left = 8+dx+ix;

        Shape2->Top = 39+dy+iy;
        Shape2->Left = 256+dx+ix;

        pb1->Top = 67+dy+iy;
        pb1->Left = 156+dx+ix;

        pb2->Top = 41+dy+iy;
        pb2->Left = 12+dx+ix;

        GuideLock->Top = 175+dy+iy;
        GuideLock->Left = 8+dx+ix;

        ToolBarList->Top = 205+dy+iy;
        ToolBarList->Left = 10+dx+ix;

        List->Top = 229+dy+iy;
        List->Left = 8+dx+ix;

        ToolBarEdit->Top = 38+dy+iy;
        ToolBarEdit->Left = 152+dx+ix;

        CaptionInput->Top = 42+dy+iy;
        CaptionInput->Left = 264+dx+ix;

        height = Height;
        /*
        if(height>Height){
                height = Height-1;
                Height = height;
                Height++;
        } else {
                height = Height;
        }
        */
}


void TeTeForm::ReDraw(bool pb1sw,bool pb2sw)
{
        if(pb1sw) pb1->Canvas->Draw( 0,0, buf1 );
        if(pb2sw) pb2->Canvas->Draw( 0,0, buf2 );

}


/***************
 mێs
***************/
void TeTeForm::ShortOfMemory(void){
        MessageDlg(
        "mۂł܂B\nAvP[V͏I܂B",
        mtError,TMsgDlgButtons() << mbOK, 0);
        Close();
}


/*******
 n
*******/
void __fastcall TeTeForm::FormDestroy(TObject *Sender)
{
        delete  buf1;
        delete  buf2;
        delete  Tan;

        int i;
        for(i=0; i<maxhisfiles; i++) delete HisMenuItem[i];

        for(i=0; i<pltFiles; i++) delete pltMenuItem[i];
        free(pltMenuItem);
        delete pltFilename;

        free(UndoBank);

}








//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yt@Cz

/**********
 VK쐬
**********/
void __fastcall TeTeForm::FileNewExecute(TObject *Sender)
{
        NewFile();
}
void TeTeForm::NewFile(void)
{
        if(! NoSaveCheck(true)) return;

        Tan->NewFile();
        List->Items->Clear();

        //Tan->GetBmp(-1,1.,buf1,false);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,true);
        Tan->PopPcs(Pcs2);

        PushUndoBank();
        EditButtons();

        DrawBar();

}

//Z[uYĂȂH
bool TeTeForm::NoSaveCheck(bool canselbutton)
{
        int i;
        const char *mes = "t@C̓eςĂ܂B\n\nۑ܂H";
        if(Tan->ModifiedFlag){
                if(canselbutton){
                        i = MessageDlg(mes,mtConfirmation,
                                TMsgDlgButtons() << mbYes << mbNo << mbCancel, 0);
                } else {
                        i = MessageDlg(mes,mtConfirmation,
                                TMsgDlgButtons() << mbYes << mbNo, 0);
                }
                switch(i){
                        case mrCancel : return false;
                        case mrYes : FileSaveExecute(NULL);
                }
        }

        return true;
}

//t@CEs[XEVGbgo[ɏ
void TeTeForm::DrawBar(void)
{
        StatusBar->Panels->Items[0]->Text = Tan->Filename;
        StatusBar->Panels->Items[1]->Text = Tan->Plt.Caption;
        StatusBar->Panels->Items[2]->Text = IntToStr(Tan->PcsTotal);

}


/*****
 J
*****/
void __fastcall TeTeForm::FileOpenExecute(TObject *Sender)
{
        if(! NoSaveCheck(true)) return;

        if (OpenDialog->Execute()){
                List->Items->Clear();

                OpenDialog->InitialDir = ExtractFileDir(OpenDialog->FileName);
                Tan->eTeLoad(OpenDialog->FileName);

                mkListNum(0,Tan->PcsTotal);

                if(Tan->PcsTotal>0){
                        Tan->PcsSelect(0);
                        List->ItemIndex = 0;
                }
                //Tan->GetBmp(-1,1.,buf1,false);
                Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                CaptionInput->Text = Tan->PopPcsCaption(-1);
                ReDraw(true,true);
                Tan->PopPcs(Pcs2);

                ToolButtonShowTable->Down = false;
        }

        if(Tan->PltChangedFlag) ResetUndo(); else PushUndoBank();
        EditButtons();

        PushHistory();

        DrawBar();

}

//qXg[t@CJ
void __fastcall TeTeForm::HisFileOpenExecute(TObject *Sender)
{
        if(! NoSaveCheck(true)) return;

        int i;
        int HisIndex = dynamic_cast<TMenuItem *>(Sender)->Tag;
        List->Items->Clear();

        OpenDialog->InitialDir = ExtractFileDir(OpenFileHistory[HisIndex]);
        Tan->eTeLoad(OpenFileHistory[HisIndex]);

        mkListNum(0,Tan->PcsTotal);

        if(Tan->PcsTotal>0){
                Tan->PcsSelect(0);
                List->ItemIndex = 0;
        }
        //Tan->GetBmp(-1,1.,buf1,false);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,true);
        Tan->PopPcs(Pcs2);

        ToolButtonShowTable->Down = false;

        if(Tan->PltChangedFlag) ResetUndo(); else PushUndoBank();
        EditButtons();

        PushHistory();

        DrawBar();


}

void TeTeForm::PushHistory(void)
{
        if(Tan->Filename == "Vt@C") return;

        int i,j;
        for(i=0; i<maxhisfiles; i++){
                if(AnsiCompareText(Tan->Filename, OpenFileHistory[i]) == 0){
                for(j=i+1; j<maxhisfiles; j++) OpenFileHistory[j-1] = OpenFileHistory[j];
                break;
                }
        }

        for(i=maxhisfiles-1; i>0; i--) OpenFileHistory[i] = OpenFileHistory[i-1];
        OpenFileHistory[0] = Tan->Filename;

        SetHistory();

}

void TeTeForm::SetHistory(void)
{
        int i;
        for(i=0; i<maxhisfiles; i++){
                if(AnsiCompareText(
                        ExtractFilePath(OpenFileHistory[i]),
                        ExtractFilePath(Application->ExeName) + "etes\\"
                        ) == 0)
                        HisMenuItem[i]->Caption = "&"+IntToStr(i)+" "+
                                ExtractFileName(OpenFileHistory[i]);
                else    HisMenuItem[i]->Caption = "&"+IntToStr(i)+" "+OpenFileHistory[i];

                if(OpenFileHistory[i] != "")
                        HisMenuItem[i]->Visible = true;
                else    HisMenuItem[i]->Visible = false;
        }

}

//t@C̃}[W
void __fastcall TeTeForm::FileMargeExecute(TObject *Sender)
{

        if((! Tan->ModifiedFlag) && (Tan->PcsTotal == 0)){
                FileOpenExecute(NULL);
                return;
        }

        TStringList* planetext = new TStringList();
        if (OpenDialog->Execute()){
                planetext->LoadFromFile(OpenDialog->FileName);

                if(planetext->Strings[0] == Tan->Plt.Name){
                        planetext->Delete(0);
                } else {
                        if(planetext->Strings[0] == "2.13" &&
                           planetext->Strings[1] == Tan->Plt.Name){
                                planetext->Delete(0);
                                planetext->Delete(0);
                        } else {
                                MessageDlg(
                                "Ή̃o[WA܂͈قȂs[XZbg̃t@CłB",
                                mtInformation,TMsgDlgButtons() << mbOK, 0);
                                delete planetext;
                                return;
                        }
                }

                if(planetext->Count < 2){
                        delete planetext;
                        return;
                }

                int i;
                for(i=0; i<planetext->Count; i+=2){
                        Tan->strPcses->Add(planetext->Strings[i]);
                        Tan->strPcses->Add(planetext->Strings[i+1]);
                }

                i = Tan->PcsTotal;
                Tan->PcsTotal += planetext->Count/2;
                mkListNum(i,planetext->Count/2);

                List->ItemIndex = i;
                Tan->PcsSelect(i);
                Tan->PopPcs(Pcs2);
                //Tan->GetBmp(-1,1.,buf1,false);
                Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                ReDraw(true,true);

                Tan->ModifiedFlag = true;
                EditButtons();

                DrawBar();

        }

        delete planetext;

}

//tH_J
void __fastcall TeTeForm::FileDirOpenExecute(TObject *Sender)
{

        if(Tan->Filename != "Vt@C"){
        if(DirectoryExists(ExtractFilePath(Tan->Filename))){
        ShellExecute(Handle,"open",ExtractFilePath(Tan->Filename).c_str(),0,0,SW_SHOW);
        return;
        }}

        if(DirectoryExists(ExtractFilePath(Application->ExeName) + "etes")){
        ShellExecute(Handle,"open",(ExtractFilePath(Application->ExeName)+"etes").c_str(),0,0,SW_SHOW);
        return;
        }

        if(DirectoryExists(ExtractFilePath(Application->ExeName))){
        ShellExecute(Handle,"open",ExtractFilePath(Application->ExeName).c_str(),0,0,SW_SHOW);
        return;
        }

}


/*******************
 s[XZbg̕ύX
*******************/
void __fastcall TeTeForm::EditChangeExecute(TObject *Sender)
{
        if (OpenDialogPlt->Execute()){
                PltLoad(ChangeFileExt(ExtractFileName(OpenDialogPlt->FileName),""));
        }
}

void TeTeForm::PltLoad(AnsiString pltname)
{
        Tan->PltLoad(pltname);

        //Tan->GetBmp(-1,1.,buf1,false);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,true);
        Tan->PopPcs(Pcs2);

        ResetUndo();
        EditButtons();

        DrawBar();
}


/***********
 ㏑ۑ
***********/
void __fastcall TeTeForm::FileSaveExecute(TObject *Sender)
{
        if(Tan->Filename == "Vt@C"){
                FileSaveAsExecute(NULL);
                return;
        } else {
                if(Tan->ModifiedFlag){
                        Tan->eTeSave(Tan->Filename);

                        EditButtons();
                }
        }

}

//Otĕۑ
void __fastcall TeTeForm::FileSaveAsExecute(TObject *Sender)
{
        SaveDialog->FileName = Tan->Filename;
	if (SaveDialog->Execute())
	{
                if(FileExists(SaveDialog->FileName)){
                        if(MessageDlg(
                        SaveDialog->FileName+"\n͂łɑ݂܂B\n\n㏑܂H",
                        mtWarning,TMsgDlgButtons() << mbYes << mbNo, 0) == mrNo)
                                return;
                }

                Tan->ModifiedFlag = true;
                Tan->eTeSave(SaveDialog->FileName);

                PushHistory();

                DrawBar();
                EditButtons();
        }

}


/*****
 I
*****/
void __fastcall TeTeForm::FileExitExecute(TObject *Sender)
{
        if(! NoSaveCheck(true)) return;
        Tan->ModifiedFlag = false;

        Close();
}

//R{{bNX̕ωflipsensɔf
void __fastcall TeTeForm::flipsensComboBoxChange(TObject *Sender)
{
        if(numcheck(StrToInt(flipsensComboBox->Text)))
                flipsens = StrToInt(flipsensComboBox->Text);

}

//Y[{̕ύX𔽉f
void __fastcall TeTeForm::Copy1PercentageComboBoxChange(TObject *Sender)
{
        if(!(StrToInt(Copy1PercentageComboBox->Text))) return;

        Tan->ZoomPercentage = StrToInt(Copy1PercentageComboBox->Text);

        Tan->PopPcs(Pcs__);
        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        Tan->PushPcs(Pcs__);
        ReDraw(false,true);

        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        }

}

//sǂ
bool TeTeForm::numcheck(AnsiString s)
{
        int i,i_ = 0;

        if(s.Length() == 0) return false;
        if(s.c_str()[0] == 0x002d){
                if(s.Length() == 1) return false;
                i_ = 1;
        }

        for( i=i_; i<s.Length(); i++ ){
                if((s.c_str()[i] < 0x0030) || (s.c_str()[i] > 0x0039))
                        return false;
        }
        return true;

}

void __fastcall TeTeForm::FormClose(TObject *Sender, TCloseAction &Action)
{
       if(! NoSaveCheck(false)) return;

        //INIt@Cɐݒۑ
        TIniFile *ini;
        ini = new TIniFile(ExtractFilePath(Application->ExeName)+"eTe.ini");
        ini->WriteInteger("VXe","dcxsmin",dcxsmin);
        ini->WriteInteger("VXe","dcxabsmax",dcxabsmax);
        ini->WriteInteger("VXe","flipsens",flipsens);
        ini->WriteInteger("VXe","fssens",fssens);
        ini->WriteInteger("VXe","aadown", (int)ToolButtonOptAA->Down);
        ini->WriteFloat("VXe","gamma", gamma);
        ini->WriteString("VXe","inidir", OpenDialog->InitialDir);
        ini->WriteString("VXe","opttbv", (int)OptToolBar->Visible);

        int i;
        for(i=0; i<10; i++)
        ini->WriteString("qXg[",IntToStr(i).c_str(),OpenFileHistory[i]);

        ini->WriteInteger("pbg","ho",    ho);
        ini->WriteInteger("pbg","hr",    hr);
        ini->WriteInteger("pbg","so",    so);
        ini->WriteInteger("pbg","sr",    sr);
        ini->WriteInteger("pbg","vo",    vo);
        ini->WriteInteger("pbg","vr",    vr);
        ini->WriteInteger("pbg","bgcolor", (int)Tan->BGColor);
        ini->WriteInteger("pbg","ho_",    ho_);
        ini->WriteInteger("pbg","hr_",    hr_);
        ini->WriteInteger("pbg","so_",    so_);
        ini->WriteInteger("pbg","sr_",    sr_);
        ini->WriteInteger("pbg","vo_",    vo_);
        ini->WriteInteger("pbg","vr_",    vr_);
        ini->WriteInteger("pbg","bgcolor_", bgcolor_);


        if(WindowState == wsNormal){
        ini->WriteInteger("|WV","top",   Top);
        ini->WriteInteger("|WV","left", Left);
        ini->WriteInteger("|WV","height",Height);
        ini->WriteInteger("|WV","width",Width);
        }
        ini->WriteInteger("|WV","sbx",   sbx);
        ini->WriteInteger("|WV","sby",   sby);
        ini->WriteInteger("|WV","sbz",   sbz);
        ini->WriteInteger("EBhE","ws", (int)WindowState);
        delete ini;

}








//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yҏWz

/*****
 j
*****/

void __fastcall TeTeForm::EditBreakExecute(TObject *Sender)
{
        Tan->NewPcs();

        if(! GuideLock->Checked) Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                else Tan->GetBmp(-1,1.,buf1,false);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,! GuideLock->Checked);
        if(! GuideLock->Checked) Tan->PopPcs(Pcs2);

        ToolButtonShowTable->Down = false;

        PushUndoBank();
        EditButtons();

}


/*********
 AhD
*********/
//UndoBank[undoPos]ɂ݂͌Pcs

//AhDZbg
void TeTeForm::ResetUndo(void)
{
        undoB = 0;
        undoF = 0;
        undoPos = 0;

        Tan->PopPcs(UndoBank[0]);
        EditButtons();

}

//AhDobt@ɃvbV
void TeTeForm::PushUndoBank(void)
{
        if(undoB<maxundo-1) undoB++;

        undoF = 0;
        undoPos = (undoPos+1) % maxundo;

        Tan->PopPcs(UndoBank[undoPos]);

}

//AhD
void __fastcall TeTeForm::EditUndoExecute(TObject *Sender)
{
        undoB--;
        undoF++;
        undoPos = (undoPos+maxundo-1) % maxundo;

        Tan->PushPcs(UndoBank[undoPos]);
        if(! GuideLock->Checked) Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                else Tan->GetBmp(-1,1.,buf1,false);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,! GuideLock->Checked);
        if(! GuideLock->Checked) Tan->PopPcs(Pcs2);

        ToolButtonShowTable->Down = false;

        EditButtons();

}

//hD
void __fastcall TeTeForm::EditRedoExecute(TObject *Sender)
{
        undoB++;
        undoF--;
        undoPos = (undoPos+1) % maxundo;

        Tan->PushPcs(UndoBank[undoPos]);
        if(! GuideLock->Checked) Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                else Tan->GetBmp(-1,1.,buf1,false);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,! GuideLock->Checked);
        if(! GuideLock->Checked) Tan->PopPcs(Pcs2);

        ToolButtonShowTable->Down = false;

        EditButtons();

}


/**********
 Xg
**********/
//hbOhbv
//hbOJn
void __fastcall TeTeForm::ListMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        if (Button == mbLeft){
                // {^ꂽƂAڂꍇɂ̓hbO
                TListBox *pLB = (TListBox *)Sender;
                if(pLB->ItemAtPos(Point(X,Y), true) >= 0){
                        pLB->BeginDrag(false, -1);
                        index1 = List->ItemIndex;
                }
        }
}

//hbO󂯓
void __fastcall TeTeForm::ListDragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept)
{
        if ( Source->ClassNameIs("TListBox") ){
                Accept = true;

                index2 = List->ItemAtPos(Point(X,Y), false);

                //Xg{bNX̏㉺[ɒBXN[
                if((index2 == List->TopIndex)&&(index2 > 0)){
                        List->TopIndex--;
                        index2--;
                }
                if((index2-List->TopIndex >= 28)&&(index2 < Tan->PcsTotal)){
                        List->TopIndex++;
                        index2 = List->TopIndex + 28;
                }

                List->Update();

                //hbv̓_g\
                if((index2 != index1) && (index2 != -1)){
                        List->Canvas->Pen->Mode = pmNot;
                        List->Canvas->Pen->Style = psDot;
                        List->Canvas->Brush->Style = bsClear;
                        //Ô
                        if(index1 != List->ItemIndex)
                                List->Canvas->Rectangle(List->ItemRect(index1));
                        //Vg`
                        if(index2 != List->ItemIndex)
                                List->Canvas->Rectangle(List->ItemRect(index2));
                        index1 = index2;
                }

        }

}

//hbv
void __fastcall TeTeForm::ListDragDrop(TObject *Sender, TObject *Source,
      int X, int Y)
{
        if (Source->InheritsFrom(__classid(TListBox))){
                int dstindex = index1;
                int srcindex = List->ItemIndex;
                if(dstindex > srcindex) dstindex--;
                if(dstindex == srcindex) return;

                //Xg̓ꊷ
                Tan->PopPcs(Pcs__);
                Tan->PcsSelect(srcindex);
                Tan->PopPcs(Pcs_);
                Tan->ListDelete(srcindex);
                if(dstindex > srcindex){
                        Tan->ListAdd(dstindex);
                        mkListNum(srcindex,dstindex-srcindex+1);
                } else {
                        Tan->ListAdd(dstindex);
                        mkListNum(dstindex,srcindex-dstindex+1);
                }

                List->ItemIndex = dstindex;
                if(ToolButtonShowTable->Down) DrawTable();
                Tan->PushPcs(Pcs__);
                EditButtons();
        }

}

//hbOI
void __fastcall TeTeForm::ListEndDrag(TObject *Sender, TObject *Target,
      int X, int Y)
{
        List->Repaint();

}


//PɈړ
void __fastcall TeTeForm::EditDownExecute(TObject *Sender)
{
        int i = List->ItemIndex;

        Tan->ListExchange(i,i+1);
        mkListNum(i,2);

        List->ItemIndex = i+1;

        if(ToolButtonShowTable->Down) DrawTable();
        EditButtons();

}

//PɈړ
void __fastcall TeTeForm::EditUpExecute(TObject *Sender)
{
        int i = List->ItemIndex;

        Tan->ListExchange(i,i-1);
        mkListNum(i-1,2);

        List->ItemIndex = i-1;

        if(ToolButtonShowTable->Down) DrawTable();
        EditButtons();

}

//XgǉCT[g[h̐؂ւ
void __fastcall TeTeForm::ToolButtonAddMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{

        if(Button == mbRight){
                if(ToolButtonAdd->ImageIndex == 43){
                         ToolButtonAdd->ImageIndex = 44;
                         Add->ImageIndex = 44;
                } else { ToolButtonAdd->ImageIndex = 43;
                         Add->ImageIndex = 43;
                }
        }

}

//Xgɒǉ
void __fastcall TeTeForm::EditAddExecute(TObject *Sender)
{
        int i = List->ItemIndex;

        Tan->ListAdd(i);
        if(i != -1){
                if(ToolButtonAdd->ImageIndex == 43){
                        List->Items->Insert(i,Tan->PopPcsCaption(-1));
                        mkListNum(i,Tan->PcsTotal-i);
                        List->ItemIndex = i;
                } else {
                        //㏑ꂽVGbg̓AhDobt@
                        Tan->PopPcs(Pcs_);
                        Tan->PcsSelect(i+1);
                        Tan->ListDelete(i+1);
                        undoB--;
                        undoPos = (undoPos+maxundo-1) % maxundo;
                        PushUndoBank();
                        Tan->PushPcs(Pcs_);
                        PushUndoBank();
                        List->Items->Strings[i] = Tan->PopPcsCaption(-1);
                        mkListNum(i,1);
                        EditButtons();
                }
        } else {
                List->Items->Add(Tan->PopPcsCaption(-1));
                mkListNum(0,Tan->PcsTotal);
                List->ItemIndex = 0;
        }

        DrawBar();

        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        if(ToolButtonShowTable->Down) DrawTable();
        ReDraw(!ToolButtonShowTable->Down,true);
        Tan->PopPcs(Pcs2);

        EditButtons();

}

//폜
//i폜f[^undoPos1R߂Ăč̈ʒu
//  ̃f[^͂̌UndoBankցj
void __fastcall TeTeForm::EditDeleteExecute(TObject *Sender)
{

        Pcs_ = Tan->Pcs;

        int i = List->ItemIndex;
        Tan->PcsSelect(i);
        Tan->ListDelete(i);
        List->Items->Delete(i);
        undoB--;
        undoPos = (undoPos+maxundo-1) % maxundo;
        PushUndoBank();

        mkListNum(i,Tan->PcsTotal-i);

        DrawBar();

        Tan->PushPcs(Pcs_);

        if(Tan->PcsTotal>0){
                if(i > Tan->PcsTotal-1) i--;
                List->ItemIndex = i;

                Tan->GetStrechedBmp(i,buf1,buf2,false,ToolButtonOptAA->Down);
                Tan->PopPcs(Pcs__);
                Tan->PcsSelect(i);
                Tan->PopPcs(Pcs2);
                Tan->PushPcs(Pcs__);

                if(ToolButtonShowTable->Down) DrawTable();
                        else Tan->GetBmp(-1,1.,buf1,false);
        } else {
                Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                Tan->PopPcs(Pcs2);

                if(ToolButtonShowTable->Down){
                        ToolButtonShowTable->Down = false;
                        ReDraw(true,false);
                }
        }
        ReDraw(false,true);

        PushUndoBank();
        EditButtons();

}

//Xgɔԍt
void TeTeForm::mkListNum(int startIdx,int n)
{
        int i;
        for(i=startIdx; i<startIdx+n; i++){
                if(i <= List->Items->Count){
                        List->Items->Strings[i] = Tan->PopPcsCaption(i);
                } else {
                        List->Items->Add( Tan->PopPcsCaption(i) );
                }
        }

}

//Xg`
void __fastcall TeTeForm::ListDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{

        List->Canvas->FillRect(Rect);
        List->Canvas->Font->Color = clInactiveCaptionText;
        List->Canvas->TextOut(
                 Rect.Left+24-List->Canvas->TextWidth(IntToStr(Index+1)),
                 Rect.Top,
                 IntToStr(Index+1).c_str() );
        List->Canvas->Font->Color = clWindowText;
        List->Canvas->TextOut(
                 Rect.Left+26,
                 Rect.Top,
                 (List->Items->Strings[Index]).c_str() );


}

//̂̕ύXPcsɔf
void __fastcall TeTeForm::CaptionInputChange(TObject *Sender)
{
        Tan->PushPcsCaption(-1,CaptionInput->Text);
}


//eҏW{^Enable؂ւ
//iłModefiedFlag`FbNj
void TeTeForm::EditButtons(void)
{
        int i = List->ItemIndex;
        if(Tan->PcsTotal < 1){
                ToolButtonChange->Enabled = true;
                Change->Enabled = true;
                OptSSort->Enabled = false;
                OptNSortLevel1->Enabled = false;
                OptNSortLevel2->Enabled = false;
                OptNSortLevel3->Enabled = false;
                OptActiveViewer->Enabled = false;
                OptmkHTML->Enabled = false;
        } else {
                ToolButtonChange->Enabled = false;
                Change->Enabled = false;
                OptSSort->Enabled = true;
                OptNSortLevel1->Enabled = true;
                OptNSortLevel2->Enabled = true;
                OptNSortLevel3->Enabled = true;
                OptActiveViewer->Enabled = true;
                OptmkHTML->Enabled = true;
        }

        if((Tan->PcsTotal == 0)||(i<0)){
                ToolButtonDelete->Enabled = false;
                ToolButtonGoEdit->Enabled = false;
                ToolButtonShowTable->Enabled = false;
                ToolButtonShowTable->Down = false;

                ToolButtonUp->Enabled = false;
                ToolButtonDown->Enabled = false;
                Delete->Enabled = false;
                GoEdit->Enabled = false;
                Up->Enabled = false;
                Down->Enabled = false;
        } else {
                ToolButtonDelete->Enabled = true;
                ToolButtonGoEdit->Enabled = true;
                ToolButtonShowTable->Enabled = true;

                Delete->Enabled = true;
                GoEdit->Enabled = true;
                if(i+1 < Tan->PcsTotal){
                        ToolButtonDown->Enabled = true;
                        Down->Enabled = true;
                } else {
                        ToolButtonDown->Enabled = false;
                        Down->Enabled = false;
                }
                if(i>0){
                        ToolButtonUp->Enabled = true;
                        Up->Enabled = true;
                } else {
                        ToolButtonUp->Enabled = false;
                        Up->Enabled = false;
                }
        }

        if(Tan->ModifiedFlag){
                eTeForm->Caption = "easy Tangram editoriύXj";
        } else {
                eTeForm->Caption = "easy Tangram editor";
        }

        if(undoB>0){
                Undo->Enabled = true;
                ToolButtonUndo->Enabled = true;
        } else {
                Undo->Enabled = false;
                ToolButtonUndo->Enabled = false;
        }
        if(undoF>0){
                Redo->Enabled = true;
                ToolButtonRedo->Enabled = true;
        } else {
                Redo->Enabled = false;
                ToolButtonRedo->Enabled = false;
        }

}


/***********************
 ɂ킩ɃXg֘A
***********************/

//XgIAk\
void __fastcall TeTeForm::ListClick(TObject *Sender)
{
        Tan->GetStrechedBmp(List->ItemIndex,buf1,buf2,false,ToolButtonOptAA->Down);
        Tan->PopPcs(Pcs__);
        Tan->PcsSelect(List->ItemIndex);
        Tan->PopPcs(Pcs2);
        Tan->PushPcs(Pcs__);
        ReDraw(false,true);

        if((ToolButtonShowTable->Down == true)
                && (ToolButtonShowTable->Enabled == true)) DrawTable();
                else Tan->GetBmp(-1,1.,buf1,false);

        EditButtons();

}

//הɂ̂
void __fastcall TeTeForm::EditGoEditExecute(TObject *Sender)
{
        ToolButtonShowTable->Down = false;

        int i = List->ItemIndex;

        Tan->PcsSelect(i);
        Tan->GetBmp(-1,1.,buf1,false);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,false);

        PushUndoBank();
        EditButtons();

}


/***************
 e[u`
***************/
void TeTeForm::DrawTable(void)
{
        int x,y,n;

        TRect Rect1;
        Rect1.Top = 0;
        Rect1.Left = 0;
        Rect1.Bottom = 512;
        Rect1.Right = 512;

        TRect Rect2;
        Rect2.Top = 0;
        Rect2.Left = 0;
        Rect2.Bottom = 64;
        Rect2.Right = 64;

        Graphics::TBitmap* minibuf = new Graphics::TBitmap();
        minibuf->PixelFormat = pf24bit;
        minibuf->Width = 64;
        minibuf->Height = 64;

        buf1->Canvas->Brush->Color = Tan->BGColor;
        buf1->Canvas->Brush->Style = bsSolid;
        buf1->Canvas->FillRect(Rect1);

        //OiF
        TColor fcolor;
        if(Tan->PltColor[0] == Tan->PltColor[1]){
                fcolor = Tan->PltColor[0];
        } else {
                fcolor = Tan->BGColor;
                if( (((int)fcolor>>16)+(((int)fcolor>>8)&255)+((int)fcolor&255))/3>127)
                        fcolor = clBlack;
                else    fcolor = clWhite;
        }

        buf1->Canvas->Font->Color = fcolor;
        buf1->Canvas->Font->Size = 7;
        for(x=-2; x<3; x++){
                for(y=-2; y<3; y++){
                        n = List->ItemIndex + y*5 + x;
                        if((n < 0) || (n > Tan->PcsTotal-1)) continue;

                        Tan->GetBmp(n,0.125,minibuf,false);

                buf1->Canvas->Draw( 224+x*100,216+y*100, minibuf );
                buf1->Canvas->TextOut( 224+x*100,280+y*100,
                        IntToStr(n+1)+"  "+Tan->PopPcsCaption(n) );
                }
        }
        pb1->Canvas->Draw( 0,0, buf1 );

        delete minibuf;

}

//e[u\ON/OFF̏
void __fastcall TeTeForm::ToolButtonShowTableClick(TObject *Sender)
{
        if(ToolButtonShowTable->Down == true) {
                DrawTable();
        } else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        };

}

//e[uI
void TeTeForm::SelectTable(void)
{
        TPoint mspos;
        mspos = pb1->ScreenToClient(Mouse->CursorPos);

        int i = List->ItemIndex+(mspos.x/106-2)+(mspos.y/106-2)*5;
        if(i<0 || i>=Tan->PcsTotal) return;

        ToolButtonShowTable->Down = false;

        List->ItemIndex = i;

        Tan->PcsSelect(i);
        //Tan->GetBmp(-1,1.,buf1,false);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        CaptionInput->Text = Tan->PopPcsCaption(-1);
        ReDraw(true,true);
        Tan->PopPcs(Pcs2);

        PushUndoBank();
        EditButtons();

}









//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ ySz

//}EX
void __fastcall TeTeForm::pb1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{

        int i,dx,dy;

        switch(pb1ActLevel){

                case 1:
                //`I[h
                        buf1->Canvas->Pen->Mode = pmNot;
                        buf1->Canvas->Pen->Style = psDot;
                        buf1->Canvas->Brush->Style = bsClear;
                        //O̎lp
                        if(RectExists)
                                buf1->Canvas->Rectangle(startpos.x,startpos.y,
                                                        lastpos.x,lastpos.y);
                        //Vlp`
                        if((abs(startpos.x-X)>20) || (abs(startpos.y-Y)>20)){
                                RectExists = true;
                                lastpos = Point(X,Y);
                                buf1->Canvas->Rectangle(startpos.x,startpos.y,
                                                        X,Y);
                        } else RectExists = false;
                        ReDraw(true,false);
                        buf1->Canvas->Pen->Mode = pmCopy;
                        buf1->Canvas->Pen->Style = psSolid;

                        break;

                case 2:
                //s[XړE][h
                        dx = Mouse->CursorPos.x- pb1->ClientToScreen(Point(256,256)).x;
                        dy = Mouse->CursorPos.y- pb1->ClientToScreen(Point(256,256)).y;

                        dcx[dcxp] = dx;
                        dcxs += dx;
                        dcxabs += abs(dx);
                        dcxp = (dcxp+1) & 1023;
                        dcxs -= dcx[(dcxp+1024-dcxn) & 1023];
                        dcxabs -= abs(dcx[(dcxp+1024-dcxn) & 1023]);
                        if((abs(dcxs)<dcxsmin)&&(dcxabs>dcxabsmax)){
                                Tan->PltFlip();
                                dcxp = 0;
                                dcxs = 0;
                                dcxabs = 0;
                                for(i=0; i<1024; i++) dcx[i] = 0;
                        }

                        Tan->PltMove(dx,dy);

                        Mouse->CursorPos = pb1->ClientToScreen(Point(256,256));
                        Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,false);

                        break;

                case 3:
                //s[X][h
                        dx = Mouse->CursorPos.x- pb1->ClientToScreen(Point(256,256)).x;
                        Tan->PltRotate(dx);

                        Mouse->CursorPos = pb1->ClientToScreen(Point(256,256));
                        Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,false);

                        break;
        }


}

//}EX{^ꂽ
void __fastcall TeTeForm::pb1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{

        int i;

        //{^
        if(Button == mbLeft){
        switch(pb1ActLevel){

                case 0:
                        //e[u\̏ꍇ̏
                        if(ToolButtonShowTable->Down) {
                                SelectTable();
                                return;
                        }
                        //s[XI̊Jn
                        pb1ActLevel ++;

                        startpos = Point(X,Y);
                        RectSelect = true;
                        RectExists = false;

                        break;

                //s[X̌Œƍĕ`
                case 2:
                        pb1ActLevel = 0;

                        if(Tan->PltActive != plAll){
                                i = Tan->PltActive;
                                Origin = Point(Tan->Pcs.X[i]+dOrigin.x,Tan->Pcs.Y[i]+dOrigin.y);
                                Mouse->CursorPos = Origin;
                        } else {
                                if(! PointSelect){
                                        Origin = Tan->GetAllRotAxis();
                                        Origin.x += dOrigin.x;
                                        Origin.y += dOrigin.y;
                                }
                                Mouse->CursorPos = Origin;
                        }

                        Tan->PltSleep();

                        pb1->Cursor = crDefault;
                        //Tan->GetBmp(-1,1.,buf1,false);
                        if(! GuideLock->Checked) Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                                else Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,! GuideLock->Checked);
                        if(! GuideLock->Checked) Tan->PopPcs(Pcs2);

                        PushUndoBank();
                        EditButtons();

                        break;

                //s[X̃AWXg]
                case 3:
                        Tan->PltRotAdjust();
                        Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,false);

                        break;

        }
        }


        //E{^
        if(Button == mbRight){
        switch(pb1ActLevel){

                //s[X̔wʈړ
                case 0:
                         Origin = Mouse->CursorPos;
                        dOrigin = pb1->ScreenToClient(Origin);
                        dOrigin = Point(Origin.x-dOrigin.x,Origin.y-dOrigin.y);
                        Tan->PltSelect(Point(Origin.x-dOrigin.x,Origin.y-dOrigin.y),buf1,false);
                        //Tan->GetBmp(-1,1.,buf1,false);
                        if(! GuideLock->Checked) Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
                                else Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,! GuideLock->Checked);
                        if(! GuideLock->Checked) Tan->PopPcs(Pcs2);

                        break;

                //s[X̉]Jn
                case 2:
                        pb1ActLevel ++;

                        Tan->AllRotRefresh();

                        break;

        }
        }


        //}EX̒{^ɂ锽]
        if((Button == mbMiddle)&&(pb1ActLevel == 2)){
                        Tan->PltFlip();
                        Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,false);
        }

}

//}EX{^ꂽ
void __fastcall TeTeForm::pb1MouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{

        int i;

        //{^
        if(Button == mbLeft){
        if(pb1ActLevel == 1){
                //s[X̑Im菈
                pb1ActLevel ++;

                Origin = Mouse->CursorPos;
                dOrigin = pb1->ScreenToClient(Origin);
                dOrigin = Point(Origin.x-dOrigin.x,Origin.y-dOrigin.y);

                if(RectExists){
                        Tan->PltSelectRect(Rect(startpos.x,startpos.y,lastpos.x,lastpos.y));
                        PointSelect = false;
                } else  {
                        Tan->PltSelect(Point(Origin.x-dOrigin.x,Origin.y-dOrigin.y),buf1,true);
                        PointSelect = true;
                }

                if(Tan->PltActive == plNone){
                        pb1ActLevel = 0;

                        Tan->GetBmp(-1,1.,buf1,false);
                        ReDraw(true,false);
                        return;
                }

                CaptionInput->SetFocus();

                pb1->Cursor = crNone;
                dcxp = 0;
                dcxs = 0;
                dcxabs = 0;
                dcxn = flipsens * fssens;
                for(i=0; i<1024; i++) dcx[i] = 0;

                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);

                Mouse->CursorPos = pb1->ClientToScreen(Point(256,256));

        }
        }


        //E{^
        if(Button == mbRight){
        if(pb1ActLevel == 3){
                pb1ActLevel --;

                Tan->AllRotRefresh();
        }
        }

}








//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ ypbgz

void __fastcall TeTeForm::PaletteCSetExecute(TObject *Sender)
{
        switch (((TMenuItem *)Sender)->Tag){
                case 1 :
                        CSet(clBlack, 0,0,255, 0,0,0);
                        break;
                case 0 :
                        CSet(clWhite, 0,0,0, 0,0,0);
                        break;
                case 3 :
                        CSet(clBlack, 166,172,156, 28,83,99);
                        break;
                case 2 :
                        CSet(clBlack, 200,172,156, 55,83,99);
                        break;
                case 4 :
                        CSet(clBlack, 28,172,146, 37,83,71);
                        break;
                case 5 :
                        CSet(clBlack, 255,255,128, 0,0,127);
                        break;
                case 6 :
                        CSet(clAppWorkSpace, 0,0,0, 0,0,0);
                        break;
        }
}

 void TeTeForm::CSet(TColor bgcolor, int h1,int s1,int v1, int h2,int s2,int v2)
{
        int i,c;


        if(bgcolor == clAppWorkSpace)
                Shape1->Pen->Color = clAppWorkSpace;
        else    Shape1->Pen->Color = clBlack;


        //mNȂK}
        if(
        (((v2 == 0) || (v1%255 == 0)) && (s1+s2 == 0)) &&
        ((bgcolor == clBlack) || (bgcolor == clWhite))
        )       Tan->mkGammaTable(gamma);
        else    Tan->mkGammaTable(1.0);

        //pbgݒ
        Tan->CSet(bgcolor, h1,s1,v1, h2,s2,v2);

        Tan->PopPcs(Pcs__);
        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        Tan->PushPcs(Pcs__);
        ReDraw(false,true);

        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        }

        ho = h1;
        hr = h2;
        so = s1;
        sr = s2;
        vo = v1;
        vr = v2;

}

//J[JX^}CY
void __fastcall TeTeForm::PaletteColorCustamizeExecute(TObject *Sender)
{
        PaletteColorCustamizeBody();

}

void __fastcall TeTeForm::ToolButtonCSetClick(TObject *Sender)
{
        if((hr == 0) && (sr == 0) && (vr == 0))
                PaletteColorCustamizeBody();
        else
                CSet(Tan->BGColor, ho,so,vo, hr,sr,vr);
}

void TeTeForm::PaletteColorCustamizeBody(void)
{
        ColorCustamizeDialog = new TColorCustamizeDialog(this);
        if(ColorCustamizeDialog->ShowModal() == mrOk){

                CSet(   ColorCustamizeDialog->BGColor_,
                        ColorCustamizeDialog->h1,
                        ColorCustamizeDialog->s1,
                        ColorCustamizeDialog->v1,
                        ColorCustamizeDialog->h2,
                        ColorCustamizeDialog->s2,
                        ColorCustamizeDialog->v2        );
        }
        delete ColorCustamizeDialog;

}










//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yIvVz
//jAXŃ\[g
void __fastcall TeTeForm::OptNSortExecute(TObject *Sender)
{
        if(!(Tan->PcsTotal > 1)) return;

        Tan->PopPcs(Pcs__);

        int r = ((TMenuItem *)Sender)->Tag;

        int *d;
        if((d = (int *)malloc(Tan->PcsTotal * sizeof(int))) == NULL){
                free(d);
                return;
        }

        Byte *ptr;
        int work[128][128];
        int x,y,xx,yy,e,i,n;
        int j,k;
        int w = 128>>r;
        int orindex = List->ItemIndex;

        Graphics::TBitmap* buf = new Graphics::TBitmap();
        buf->PixelFormat = pf24bit;
        buf->Width = 128;
        buf->Height = 128;

        ProgressBar->Progress = 0;
        ProgressBar->MaxValue = Tan->PcsTotal;
        ProgressBar->Visible = true;

        buf->Canvas->Brush->Color = Tan->BGColor;
        buf->Canvas->FillRect( Rect(0,0,128,128) );
        ptr = (Byte *)buf->ScanLine[0];
        j = *ptr++ <<16;
        j |= *ptr++ <<8;
        j |= *ptr++;

        for( n=0; n<Tan->PcsTotal; n++ ){
                Tan->GetStrechedBmp(n,buf1,buf,false,false);

                //work
                for( y=0; y<w; y++ ){
                        for( x=0; x<w; x++ ){
                                work[x][y] = 0;
                        }
                }

                //e
                for( y=0; y<128; y++ ){
                        ptr = (Byte *)buf->ScanLine[y];
                        for( x=0; x<128; x++ ){
                                k = *ptr++ <<16;
                                k |= *ptr++ <<8;
                                k |= *ptr++;
                                if(k == j){
                                        work[x>>r][y>>r]--;
                                } else {
                                        work[x>>r][y>>r]++;
                                }
                        }
                }


                //ŋߐڃsNZƂ̖xςvZ
                e = 0;
                for( y=0; y<w-1; y++){
                        for( x=0; x<w-1; x++){
                                e+= work[x][y] * (work[x+1][y] + work[x][y+1]);
                        }
                        e+= work[w-1][y] * work[w-1][y+1];
                }
                for( x=0; x<w-1; x++){
                        e+= work[x][y] * work[x+1][y];
                }

                //\[g
                d[n] = e;
                for( i=0; i<n; i++){
                        if(e>d[n-i-1]){
                                d[n-i] = d[n-i-1];
                                d[n-i-1] = e;
                        } else break;
                }
                if((n != 0) && (i != 0)){
                        Tan->PcsSelect(n);
                        Tan->ListDelete(n);
                        Tan->ListAdd(n-i);
                        if(n == orindex){
                                orindex = n-i;
                        } else {
                                if((n > orindex)&&(n-i <= orindex)) orindex++;
                        }
                }

                ProgressBar->Progress = n+1;

        }

        mkListNum(0,Tan->PcsTotal);
        List->ItemIndex = orindex;

        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        Tan->PushPcs(Pcs__);
        ReDraw(false,true);

        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        }

        ProgressBar->Visible = false;
        EditButtons();

        delete d;
        delete buf;

}

//Ń\[g
void __fastcall TeTeForm::OptSSortExecute(TObject *Sender)
{
        if(!(Tan->PcsTotal > 1)) return;

        Tan->PopPcs(Pcs__);

        int i,n;
        int orindex = List->ItemIndex;
        TStringList* buf = new TStringList();

        ProgressBar->Progress = 0;
        ProgressBar->MaxValue = Tan->PcsTotal;
        ProgressBar->Visible = true;

        buf->Clear();

        for( n=0; n<Tan->PcsTotal; n++ ){

                //\[g
                buf->Find(Tan->PopPcsCaption(n),i);
                buf->Insert(i,Tan->PopPcsCaption(n));
                Tan->PcsSelect(n);
                Tan->ListDelete(n);
                Tan->ListAdd(i);
                if(n == orindex){
                        orindex = i;
                } else {
                        if((n > orindex)&&(i <= orindex)) orindex++;
                }

                ProgressBar->Progress = n+1;

        }

        mkListNum(0,Tan->PcsTotal);
        List->ItemIndex = orindex;

        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        Tan->PushPcs(Pcs__);
        ReDraw(false,true);

        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        }

        ProgressBar->Visible = false;
        EditButtons();

        delete buf;


}









//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ ywvz
//o[W
void __fastcall TeTeForm::HelpAboutExecute(TObject *Sender)
{
        AboutBox = new TAboutBox(this);
        AboutBox->ShowModal();
        delete AboutBox;

}
//wvڎ
void __fastcall TeTeForm::HelpQRefferenceExecute(TObject *Sender)
{
  Application->HelpFile = ExtractFilePath(Application->ExeName) +"eTe.hlp";
  Application->HelpCommand(HELP_FINDER, 0);

}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yIvVz
//摜Nbv{[hɃRs[
void __fastcall TeTeForm::ClipCopy1Execute(TObject *Sender)
{
        //int percentage = StrToInt(Copy1PercentageComboBox->Text);

        //StrechClipCopy(percentage);
        StrechClipCopy(100);

}

void __fastcall TeTeForm::ClipCopy2Execute(TObject *Sender)
{
        Clipboard()->Assign(buf2);

}


void TeTeForm::StrechClipCopy(int percentage)
{
        int i,j,pixel;
        pixel = 512*percentage/100;

        TRect rect;
        rect.Top = 0;
        rect.Left = 0;
        rect.Bottom = pixel;
        rect.Right = pixel;

        Graphics::TBitmap* buf = new Graphics::TBitmap();
        buf->PixelFormat = pf24bit;
        buf->Width = pixel;
        buf->Height = pixel;

        if(percentage == 100){
                Tan->GetBmp(-1,1.,buf,false);
        } else {
                if((percentage == 25) || (percentage == 50)) {
                        buf->Canvas->StretchDraw(rect,buf1);
                } else {
                        Tan->GetBmp(-1,(double)percentage/100.,buf,false);
                }
        }

        Clipboard()->Assign(buf);

        delete buf;

}

//A`GCAX̓
void __fastcall TeTeForm::AAClick(TObject *Sender)
{
        ToolButtonOptAA->Down = !(ToolButtonOptAA->Down);
        OptAAExecute(this);

}
void __fastcall TeTeForm::OptAAExecute(TObject *Sender)
{
        AA->Checked = ToolButtonOptAA->Down;

        Tan->PopPcs(Pcs__);
        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        Tan->PushPcs(Pcs__);
        ReDraw(false,true);

        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
        }

}

//IvVc[{^̓
void __fastcall TeTeForm::OptEyeExecute(TObject *Sender)
{
        OptToolBar->Visible = !(OptToolBar->Visible);

}


//s[XZbgʂ薼őI
void __fastcall TeTeForm::PltSLoadExecute(TObject *Sender)
{
        int pltTag = dynamic_cast<TMenuItem *>(Sender)->Tag;

        if(pltTag<0){
                Tan->SetDefault();
                NewFile();
                return;
        }

        PltLoad(pltFilename->Strings[pltTag]);

}


//~ʏ̍WvZ@
void __fastcall TeTeForm::OptRpcalExecute(TObject *Sender)
{

        Visible = false;

        RpcalForm = new TRpcalForm(this);
        RpcalForm->ShowModal();
        delete RpcalForm;

        Visible = true;

}


//r[A
void __fastcall TeTeForm::OptActiveViewerExecute(TObject *Sender)
{

        Visible = false;

        Tan->PopPcs(Pcs_);

        buf1->Canvas->Brush->Style = bsSolid;
        buf1->Canvas->Brush->Color = clBlack;
        buf1->Canvas->Rectangle(0,0,512,512);

        ActVForm = new TActVForm(this);
        ActVForm->ShowModal();
        delete ActVForm;

        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        ReDraw(false,true);

        Tan->PushPcs(Pcs_);
        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        }

        Visible = true;

}

//HTMLJ^O̍쐬
void __fastcall TeTeForm::OptmkHTMLExecute(TObject *Sender)
{

        //
        if(MessageDlg("HTMLt@CƉ摜tH_[́Aetet@CƓtH_ɍ쐬܂B",
        mtInformation, TMsgDlgButtons() << mbOK << mbCancel, 0) == mrCancel) return;

        AnsiString pdir = ExtractFilePath(Tan->Filename)
                + ChangeFileExt(ExtractFileName(Tan->Filename),"");

        //*_filestH_[̍쐬
        if(! DirectoryExists(pdir+"_files")) CreateDir(pdir+"_files");


        Tan->PopPcs(Pcs_);

        //{
        //--------------------------
        const int maxwidth = 680;
        int i,j,x,y,xx,yy,ex,exx;
        int lenpic,lenstr;
        TColor fcolor,bcolor;
        Byte*  ptr;
        Byte* mptr;
        TRect rect;
        bool pngerror;
        TStringList* html = new TStringList();

        //OiF
        if(Tan->PltColor[0] == Tan->PltColor[1]){
                fcolor = Tan->PltColor[0];
        } else {
                fcolor = Tan->BGColor;
                if( (((int)fcolor>>16)+(((int)fcolor>>8)&255)+((int)fcolor&255))/3>127)
                        fcolor = clBlack;
                else    fcolor = clWhite;
        }

        Graphics::TBitmap* buf = new Graphics::TBitmap();
        buf->PixelFormat = pf24bit;
        buf->Width = 128;
        buf->Height = 128;

        Graphics::TBitmap* mbuf = new Graphics::TBitmap();
        mbuf->PixelFormat = pf24bit;
        mbuf->Width = maxwidth;
        mbuf->Height = 144;
        mbuf->Canvas->Font->Size = 9;

        //摜wiF
        mbuf->Canvas->Brush->Color = Tan->BGColor;
        mbuf->Canvas->FillRect( Rect( 0,0,maxwidth,144 ) );
        bcolor = mbuf->Canvas->Pixels[0][0];

        ProgressBar->Progress = 0;
        ProgressBar->MaxValue = Tan->PcsTotal;
        ProgressBar->Visible = true;

        //
        html->Clear();
        html->Add("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">");
        html->Add("<html lang=\"ja\">");
        html->Add("");
        html->Add("<head>");
        html->Add("<title>"+ChangeFileExt(ExtractFileName(Tan->Filename),"")+"</title>");
	html->Add("<meta http-equiv=\"Content-Type\" content=\"text/html;charset=x-sjis\">");
	html->Add("<meta http-equiv=\"Content-Style-Type\" content=\"text/css\">");
        html->Add("</head>");
        html->Add("");
        html->Add("<body style=\"background-color:#"
        +IntToHex((((int)bcolor>>16)&255)|((int)bcolor&0xff00)|(((int)bcolor&255)<<16),6)
        +"\">");
        html->Add("<span style=\"font-size:24px; color:#"
        +IntToHex((((int)fcolor>>16)&255)|((int)fcolor&0xff00)|(((int)fcolor&255)<<16),6)
        +"\">"
        +ChangeFileExt(ExtractFileName(Tan->Filename),"")
        +"</span><br>");
        html->Add("<span style=\"font-size:10px; color:#"
        +IntToHex((((int)fcolor>>16)&255)|((int)fcolor&0xff00)|(((int)fcolor&255)<<16),6)
        +"\">"
        +DateToStr(Date())
        +"</span><br>");
        html->Add("<div style=\"text-align:center\">");
        //

        for(i=0; i<Tan->PcsTotal; ){
                mbuf->Width = maxwidth;
                mbuf->Canvas->Brush->Color = bcolor;
                mbuf->Canvas->FillRect( Rect( 0,0,maxwidth,144 ) );

                x = 0;
                for(i=i; i<Tan->PcsTotal; i++){
                        Tan->PcsSelect(i);

                        rect = Tan->GetMinimumRect(0.25);
                        rect.Top -=2;
                        rect.Bottom +=6;
                        rect.Left -=3;
                        rect.Right +=3;

                        if(rect.Top<0) rect.Top = 0;
                        if(rect.Left<0) rect.Left = 0;
                        if(rect.Right>127) rect.Right = 127;
                        if(rect.Bottom>127) rect.Bottom = 127;

                        lenpic = rect.Right - rect.Left;
                        lenstr = mbuf->Canvas->TextWidth(List->Items->Strings[i]);
                        if(lenpic>lenstr) xx = lenpic+6; else xx = lenstr+16;
                        if(x+xx>maxwidth) break;

                        Tan->GetStrechedBmp(-1,buf1,buf,false,ToolButtonOptAA->Down);

                        yy = rect.Bottom-rect.Top;
                        for(y=0; y<yy; y++){
                                ptr = (Byte *)buf->ScanLine[rect.Top+y];
                                mptr = (Byte *)mbuf->ScanLine[128-yy+y];
                                mptr += (x+(xx-lenpic)/2)*3;
                                ptr += rect.Left*3;
                                for(j=0; j<lenpic*3; j++) *mptr++ = *ptr++;
                        }

                        mbuf->Canvas->Font->Color = fcolor;
                        mbuf->Canvas->TextOut( x+(xx-lenstr)/2,128,List->Items->Strings[i]);
                        x += xx;

                        ProgressBar->Progress = i+1;
                }

                mbuf->Width = x;
                pngerror = !pngout(pdir+"_files\\"+IntToStr(i)+".png", mbuf);
                if(pngerror) break;

                //
                html->Add(" <p><img src=\""
                        +ChangeFileExt(ExtractFileName(Tan->Filename),"")+"_files"
                        +"\\"+IntToStr(i)
                        +".png\" style=\"width:"+IntToStr(x)+"px; height:144px\"></p>");
                //
        }

        //
        html->Add("");
        html->Add("</div>");
        html->Add("</body>");
        html->Add("");
        html->Add("</html>");
        html->SaveToFile(pdir+".htm");
        //

        Tan->PushPcs(Pcs2);
        Tan->GetStrechedBmp(-1,buf1,buf2,false,ToolButtonOptAA->Down);
        ReDraw(false,true);
        Tan->PushPcs(Pcs_);
        if(ToolButtonShowTable->Down)
                DrawTable();
        else {
                Tan->GetBmp(-1,1.,buf1,false);
                ReDraw(true,false);
        }

        ProgressBar->Visible = false;
        EditButtons();

        delete buf;
        delete mbuf;
        delete html;


        //At^[PA
        if(pngerror){
                MessageDlg(
                "png摜o͂Ɏs܂B",
                mtInformation, TMsgDlgButtons() << mbOK, 0);
                return;
        }

        if(MessageDlg(
        "J^O܂B\nHTMLt@C쐬ꂽtH_[GNXv[ŊJ܂H",
        mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes)
        ShellExecute(Handle,"open",ExtractFilePath(Tan->Filename).c_str(),0,0,SW_SHOW);

}

bool TeTeForm::pngout(AnsiString Filename,Graphics::TBitmap* bmp)
{
        bool rslt = false;
        FILE *fp;

        png_structp png_ptr;
        png_infop   info_ptr;
        int     x,y;
        Byte**  image_rows;
        Byte    *src, *dst;

        image_rows = (Byte **)malloc(bmp->Height * sizeof(Byte *));
        if (image_rows == NULL) goto ex;

        for ( y = 0 ; y < bmp->Height ; y++ ) {
                image_rows[y] = (Byte *)malloc( sizeof(Byte) * bmp->Width * 3);
                dst = image_rows[y];
                src = (Byte *)bmp->ScanLine[y];
                for ( x = 0 ; x < bmp->Width ; x++ ){
                        //RGB  BGR
                        *dst++ = *(src++ +2);
                        *dst++ = *src++;
                        *dst++ = *(src++ -2);
                }
        }

        //pngo
        png_ptr = png_create_write_struct( PNG_LIBPNG_VER_STRING,
                NULL, NULL, NULL );

        info_ptr = png_create_info_struct(png_ptr);

        if ( info_ptr==NULL || png_ptr==NULL ) goto ex;

        fp = fopen(Filename.c_str(), "wb");
        if(!fp) goto ex;
        png_init_io(png_ptr, fp);

        png_set_IHDR(png_ptr, info_ptr, bmp->Width, bmp->Height, 8,
                PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT,
                PNG_FILTER_TYPE_DEFAULT);

        png_write_info(png_ptr, info_ptr);
        png_write_image(png_ptr, image_rows);
        png_write_end(png_ptr, info_ptr);

        fclose(fp);
        rslt = true;
        ex:
        // G[̏
        if (png_ptr || info_ptr) png_destroy_write_struct(&png_ptr, &info_ptr);
        if (image_rows) {
                for ( y = 0 ; y < bmp->Height ; y++ ) {
                        if (image_rows[y]) free(image_rows[y]);
                }
                free(image_rows);
        }

        //
        return rslt;

}


//---------------------------------------------------------------------------

