//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
USERES("eTe.res");
USEFORM("About.cpp", AboutBox);
USEFORM("Color.cpp", ColorCustamizeDialog);
USEUNIT("Tangram.cpp");
USEFORM("Rpcal.cpp", RpcalForm);
USEFORM("Main.cpp", eTeForm);
USEFORM("ActiveViewer.cpp", ActVForm);
USEUNIT("adler32.c");
USEUNIT("compress.c");
USEUNIT("crc32.c");
USEUNIT("deflate.c");
USEUNIT("gzio.c");
USEUNIT("infblock.c");
USEUNIT("infcodes.c");
USEUNIT("inffast.c");
USEUNIT("inflate.c");
USEUNIT("inftrees.c");
USEUNIT("infutil.c");
USEUNIT("maketree.c");
USEUNIT("minigzip.c");
USEUNIT("png.c");
USEUNIT("pngerror.c");
USEUNIT("pnggccrd.c");
USEUNIT("pngget.c");
USEUNIT("pngmem.c");
USEUNIT("pngpread.c");
USEUNIT("pngread.c");
USEUNIT("pngrio.c");
USEUNIT("pngrtran.c");
USEUNIT("pngrutil.c");
USEUNIT("pngset.c");
USEUNIT("pngtest.c");
USEUNIT("pngtrans.c");
USEUNIT("pngvcrd.c");
USEUNIT("pngwio.c");
USEUNIT("pngwrite.c");
USEUNIT("pngwtran.c");
USEUNIT("pngwutil.c");
USEUNIT("trees.c");
USEUNIT("uncompr.c");
USEUNIT("zutil.c");
USEUNIT("Colors.cpp");
USEFORM("ColorSelecter.cpp", ColorSelecterForm);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
        //dN̖h~
        HANDLE mutexhandle = CreateMutex( NULL, false, "eTe" );
        if( mutexhandle != NULL && GetLastError( ) == ERROR_ALREADY_EXISTS ){
        		CloseHandle( mutexhandle );
        		return -1;
        }

        try
        {
                 Application->Initialize();
		 Application->Title = "easy Tangram editor";
                 Application->HelpFile = "eTe.hlp";
                 Application->CreateForm(__classid(TeTeForm), &eTeForm);
                 Application->Run();
        }
        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }

	if( mutexhandle != NULL ) CloseHandle( mutexhandle );

        return 0;
}
//---------------------------------------------------------------------------
