//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ActiveViewer.h"
#include "Main.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TActVForm *ActVForm;
//---------------------------------------------------------------------------
//RXgN^
//---------------------------------------------------------------------------
__fastcall TActVForm::TActVForm(TComponent* Owner)
        : TForm(Owner)
{

        //wipobt@
        bg = new Graphics::TBitmap();

        Deact = Application->OnDeactivate;
        Act = Application->OnActivate;
        Application->OnDeactivate = AppDeactivate;
        Application->OnActivate = AppActivate;

        OpenAndStart();
        travel = false;

}


//---------------------------------------------------------------------------
//fXgN^
//---------------------------------------------------------------------------
void __fastcall TActVForm::FormDestroy(TObject *Sender)
{
        Application->OnDeactivate = Deact;
        Application->OnActivate = Act;
        delete bg;

}


//---------------------------------------------------------------------------
//EBhEƃ^C}[̃ANeBuEANeBu؂芷𓯊
//---------------------------------------------------------------------------
void __fastcall TActVForm::AppDeactivate(TObject *Sender)
{
        if(Timer->Enabled) PlayAndPauseBody();

}

void __fastcall TActVForm::AppActivate(TObject *Sender)
{
        if(!Timer->Enabled) PlayAndPauseBody();

}


//---------------------------------------------------------------------------
//ʂ̕`
//---------------------------------------------------------------------------
void __fastcall TActVForm::FormPaint(TObject *Sender)
{

        if(Timer->Enabled) return;
        PaintBox->Canvas->Draw( 0,0,eTeForm->buf2 );

}


//---------------------------------------------------------------------------
//X^[g
//---------------------------------------------------------------------------
void TActVForm::OpenAndStart(void)
{

        //Ԍo߃p[^qƃCfbNXln̏
        q = 0.;
        n = (eTeForm->List->ItemIndex+1+eTeForm->Tan->PcsTotal)
                % eTeForm->Tan->PcsTotal;

        //n߂̃VGbgZbg
        eTeForm->Tan->PcsSelect(eTeForm->List->ItemIndex);
        eTeForm->Tan->PopPcs(Pcs2);
        eTeForm->Tan->PcsSelect(n);
        eTeForm->Tan->PopPcs(Pcs1);

        //t@Cʂɕ\
        FilenameArea->Caption
                = ChangeFileExt(ExtractFileName(eTeForm->Tan->Filename),"");

        //gqbmpɕt
        AnsiString s = ChangeFileExt(eTeForm->Tan->Filename,".bmp");

        //wi摜T
        int graphicsID = -1;
        int jpegflag = false;
        trns = false;
        trnsmode = false;
        if(!(FileExists(s))){
          //jpeg摜T
          s = ChangeFileExt(eTeForm->Tan->Filename,".jpg");
          if(!(FileExists(s))){
                s = ExtractFilePath(Application->ExeName) + "photo";
                if(random(2) == 0){
                        s += "A";
                        graphicsID = 0;
                } else {
                        s += "B";
                        graphicsID = 1;
                }
                s += ".jpg";
                if(!(FileExists(s))){
                        s="";
                        graphicsID = -1;
                } else jpegflag = true;
          } else jpegflag = true;
        }

        TRect Rect;
        Rect.Top = 0;
        Rect.Left = 0;
        Rect.Bottom = 512;
        Rect.Right = 512;

        //wi摜Γǂݍ݁A߃I߉Ƃ
        if(s != ""){
                if(jpegflag){
                        TJPEGImage* jp = new TJPEGImage();
                        jp->LoadFromFile(s);
                        bg->Width = jp->Width;
                        bg->Height = jp->Height;
                        jp->DIBNeeded();
                        bg->Assign(jp);
                        delete jp;
                } else {
                        bg->LoadFromFile(s);
                }
                trns = true;
                trnsmode = true;

                //摜TCYĂ512~512sNZɊgk
                if((bg->Width != 512) || (bg->Height != 512)){
                        eTeForm->buf1->Canvas->StretchDraw(Rect,bg);
                        bg->Width = 512;
                        bg->Height = 512;
                        bg->Canvas->Draw(0,0,eTeForm->buf1);
                }
        }


        //NWbg̊mF
        int x,y,m,sum = 0;
        Byte *ptr;
        if(graphicsID != -1){
                bg->PixelFormat = pf24bit;
                for( y=0; y<512; y++ ){
                        ptr = (Byte *)bg->ScanLine[y];
                        for( x=0; x<512*3; x++) sum = (sum+ *ptr++ )&0x7fffffff;
                }

                if(! ( ((sum ==  59716334) && (graphicsID == 1)) ||
                       ((sum == 113626382) && (graphicsID == 0)) ) )
                        graphicsID = -1;
        }

        if(graphicsID == -1){
                CreditArea->Caption = "";
                CreditArea->Hint = "";
                CreditArea->ShowHint = false;
        } else {
                CreditArea->Caption = "Photo by |q";
                CreditArea->Hint =
                        "artworks]http://www.artworks-inter.net";
                CreditArea->ShowHint = true;
                CreditArea->Visible = true;
        }
        //CreditArea->Caption = IntToStr(sum);

        //^C}[I_
        Timer->Enabled = true;
        PlayAndPause->Font->Color = clRed;


}


//---------------------------------------------------------------------------
//^C}[
//---------------------------------------------------------------------------
void __fastcall TActVForm::TimerTimer(TObject *Sender)
{

        if(travel){
                Left = Mouse->CursorPos.x-8;
                Top = Mouse->CursorPos.y-80;
                if(! timer) return;
        }


        int i,j;
        double p,r;

        q += 0.1;
        if(q >= 14.) q = 0.;

        if(q == 0.){
                eTeForm->Tan->PcsSelect(n);
                eTeForm->Tan->PopPcs(Pcs2);
                n = (n+1) % eTeForm->Tan->PcsTotal;
                eTeForm->Tan->PcsSelect(n);
                eTeForm->Tan->PopPcs(Pcs1);
        }

        //q=0.6t߂ŃLvV̓ꊷ
        if((int)(q*10) == 6){
                CaptionArea->Caption = Pcs1.Caption;
                Number->Caption = IntToStr(n+1)+"/"+IntToStr(eTeForm->Tan->PcsTotal);
        }


        //ό`IĂAĕ`vȂΕ`Ȃ
        if((q-(double)eTeForm->Tan->Plt.Plates/4.>2.) && (!redrawflag)) return;
        redrawflag = false;

        //Ԍ`̐
        for( i=0; i<eTeForm->Tan->Plt.Plates; i++ ){
                r = q-(double)i/4.;
                if(r < 0.) r = 0.;
                if(r > 2.) r = 2.;
                p = -(cos(M_PI*r/2)-1)/2.;
                Pcs.X[i] = (int)((double)Pcs1.X[i]*p + (double)Pcs2.X[i]*(1-p));
                Pcs.Y[i] = (int)((double)Pcs1.Y[i]*p + (double)Pcs2.Y[i]*(1-p));
                Pcs.dDeg[i] = (int)((double)Pcs1.dDeg[i]*p + (double)Pcs2.dDeg[i]*(1-p));
                Pcs.Flip[i] = Pcs1.Flip[i]*p + Pcs2.Flip[i]*(1-p);
        }

        eTeForm->Tan->PushPcs(Pcs);

        //߂Ȃwi`Ă
        if(trns) eTeForm->buf1->Canvas->Draw( 0,0,bg );

        //`
        eTeForm->Tan->GetBmp(-1,1.,eTeForm->buf1,trns);


        buf1toPaintBox();

}

void TActVForm::buf1toPaintBox(void)
{
        //A`GCAX
        if(eTeForm->ToolButtonOptAA->Down){
                int c[3][128][128];
                int i,m,n;
                Byte *ptr;
                for( m=0; m<128; m++ ){
                        for( n=0; n<128; n++){
                                for( i=0; i<3; i++) c[i][n][m] = 0;
                        }
                }
                for( m=0; m<512; m++ ){
                        ptr = (Byte *)eTeForm->buf1->ScanLine[m];
                        for( n=0; n<512; n++){
                                c[0][n>>2][m>>2] += *ptr++;
                                c[1][n>>2][m>>2] += *ptr++;
                                c[2][n>>2][m>>2] += *ptr++;
                        }
                }
                for( m=0; m<128; m++ ){
                        ptr = (Byte *)eTeForm->buf2->ScanLine[m];
                        for( n=0; n<128; n++){
                                *ptr++ = c[0][n][m]>>4;
                                *ptr++ = c[1][n][m]>>4;
                                *ptr++ = c[2][n][m]>>4;
                        }
                }

        } else  eTeForm->buf2->Canvas->StretchDraw( Rect(0,0,128,128),eTeForm->buf1 );

        PaintBox->Canvas->Draw( 0,0,eTeForm->buf2 );

}


//---------------------------------------------------------------------------
//摜̃NbNɂ蓧߂̃IEIt؊
//---------------------------------------------------------------------------
void __fastcall TActVForm::PaintBoxClick(TObject *Sender)
{

        //ߕsȂ؊Ȃ
        if(!trnsmode) return;

        //ߐ؊
        trns = !(trns);
        redrawflag = true;

        //s߂ȂNWbg͕\Ȃ
        if(trns){
                CreditArea->Visible = true;
        } else {
                CreditArea->Visible = false;
        }

        //^C}[It̏ꍇ͎蓮ŕ`
        if(!Timer->Enabled){

                if(trns) eTeForm->buf1->Canvas->Draw( 0,0,bg );

                eTeForm->Tan->GetBmp(-1,1.,eTeForm->buf1,trns);
                buf1toPaintBox();
        }

}


//---------------------------------------------------------------------------
//XgbvƍĐEiނƖ߂
//---------------------------------------------------------------------------
void __fastcall TActVForm::PlayAndPauseClick(TObject *Sender)
{
        PlayAndPauseBody();

}
void TActVForm::PlayAndPauseBody(void)
{
        if(Timer->Enabled){
                Timer->Enabled = false;
                PlayAndPause->Font->Color = clMaroon;
        } else {
                Timer->Enabled = true;
                PlayAndPause->Font->Color = clRed;
        }
}

//ȉCfbNX̑₱̂Œ
//߂//i
void __fastcall TActVForm::StepBackMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        if(Timer->Enabled){
                n = (n-2+eTeForm->Tan->PcsTotal) % eTeForm->Tan->PcsTotal;
                eTeForm->Tan->PcsSelect(n);
                eTeForm->Tan->PopPcs(Pcs2);
                n = (n+1) % eTeForm->Tan->PcsTotal;
                eTeForm->Tan->PcsSelect(n);
                eTeForm->Tan->PopPcs(Pcs1);

                ShowCaption();
                redrawflag = true;

        } else {
                if(q > 0.){
                        n = (n-1+eTeForm->Tan->PcsTotal) % eTeForm->Tan->PcsTotal;
                } else {
                        n = (n-2+eTeForm->Tan->PcsTotal) % eTeForm->Tan->PcsTotal;
                }
                StaticDraw();
        }

}

void __fastcall TActVForm::GoForwardMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        if(Timer->Enabled){
                eTeForm->Tan->PcsSelect(n);
                eTeForm->Tan->PopPcs(Pcs2);
                n = (n+1) % eTeForm->Tan->PcsTotal;
                eTeForm->Tan->PcsSelect(n);
                eTeForm->Tan->PopPcs(Pcs1);

                ShowCaption();
                redrawflag = true;

        } else {
                if(q > 3.){
                        n = (n+1+eTeForm->Tan->PcsTotal) % eTeForm->Tan->PcsTotal;
                }
                StaticDraw();
        }

}//i񂾂߂肵ꍇ̃LvV̒
void TActVForm::ShowCaption(void)
{
        if((int)(q*10) > 6){
                CaptionArea->Caption = Pcs1.Caption;
                Number->Caption = IntToStr(n+1)+"/"+IntToStr(eTeForm->Tan->PcsTotal);
        } else {
                CaptionArea->Caption = Pcs2.Caption;
                Number->Caption = IntToStr(n+1)+"/"+IntToStr(eTeForm->Tan->PcsTotal);
        }
}

//^C}[It̏ꍇ̓VGbg蓮ŕ`
void TActVForm::StaticDraw(void)
{
        q = 0.;
        eTeForm->Tan->PcsSelect(n);
        eTeForm->Tan->PopPcs(Pcs2);
        int m;
        m = n;
        n = (n+1) % eTeForm->Tan->PcsTotal;
        eTeForm->Tan->PcsSelect(n);
        eTeForm->Tan->PopPcs(Pcs1);

        CaptionArea->Caption = Pcs2.Caption;
        Number->Caption = IntToStr(m+1)+"/"+IntToStr(eTeForm->Tan->PcsTotal);

        if(trns) eTeForm->buf1->Canvas->Draw( 0,0,bg );

        eTeForm->Tan->PushPcs(Pcs2);
        eTeForm->Tan->GetBmp(-1,1.,eTeForm->buf1,trns);
        buf1toPaintBox();
        
}

//---------------------------------------------------------------------------
void __fastcall TActVForm::Panel1Click(TObject *Sender)
{

        if(travel) travel = false; else travel = true;
        if(travel) timer = Timer->Enabled;

        if(travel) Timer->Enabled = true; else Timer->Enabled = timer;

}

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------


