//---------------------------------------------------------------------------

#ifndef ActiveViewerH
#define ActiveViewerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ActnList.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Filectrl.hpp>
#include <jpeg.hpp>
#include "Tangram.h"


//---------------------------------------------------------------------------
class TActVForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
        TTimer *Timer;
        TPaintBox *PaintBox;
        TLabel *CaptionArea;
        TLabel *FilenameArea;
        TLabel *CreditArea;
        TLabel *PlayAndPause;
        TLabel *StepBack;
        TLabel *GoForward;
        TPanel *Panel1;
        TButton *OKButton;
        TShape *Shape1;
        TBevel *Bevel1;
        TLabel *Number;
        TShape *Shape2;
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall TimerTimer(TObject *Sender);
        void __fastcall PaintBoxClick(TObject *Sender);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall PlayAndPauseClick(TObject *Sender);
        void __fastcall AppDeactivate(TObject *Sender);
        void __fastcall AppActivate(TObject *Sender);
        void __fastcall StepBackMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall GoForwardMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Panel1Click(TObject *Sender);
private:
        void OpenAndStart(void);
        void ShowCaption(void);
        void StaticDraw(void);
        void PlayAndPauseBody(void);
        void buf1toPaintBox(void);
public:
        __fastcall TActVForm(TComponent* Owner);

        Graphics::TBitmap* bg;

        TPcs Pcs,Pcs1,Pcs2;
        TNotifyEvent Act,Deact;
        
        int fsw;
        bool trns;
        bool trnsmode;
        bool redrawflag;

        bool travel;
        bool timer;

        int n;

        float q;

};
//---------------------------------------------------------------------------
extern PACKAGE TActVForm *ActVForm;
//---------------------------------------------------------------------------
#endif

