//----------------------------------------------------------------------------
#ifndef ColorH
#define ColorH
//----------------------------------------------------------------------------
#include "Main.h"
#include <vcl\System.hpp>
#include <vcl\Windows.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>

//----------------------------------------------------------------------------
class TColorCustamizeDialog : public TForm
{
__published:
        TTrackBar *TBS2;
        TTrackBar *TBV2;
        TTrackBar *TBS1;
        TTrackBar *TBH2;
        TTrackBar *TBH1;
        TTrackBar *TBV1;
        TRadioGroup *RadioGroup1;
        TGroupBox *GroupBox1;
        TGroupBox *GroupBox2;
        TGroupBox *GroupBox3;
        TPanel *Panel1;
        TButton *CancelBtn;
        TShape *Shape2;
        TBevel *Bevel1;
        TImage *pb;
        TButton *OKBtn;
        TShape *Shape1;
        TBevel *Bevel2;
        TLabel *Label1;
        TLabel *Label2;
        void __fastcall CallDrawpalette(TObject *Sender);
        void __fastcall Drawpalette(void);
        void __fastcall RectposSet(TObject *Sender);
        void __fastcall RadioGroup1Click(TObject *Sender);
        void __fastcall TBH1Change(TObject *Sender);
        void __fastcall TBH2Change(TObject *Sender);
        void __fastcall TBS1Change(TObject *Sender);
        void __fastcall TBS2Change(TObject *Sender);
        void __fastcall TBV1Change(TObject *Sender);
        void __fastcall TBV2Change(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall pbClick(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
private:
public:
	virtual __fastcall TColorCustamizeDialog(TComponent* AOwner);
        TColor BGColor_;
        int h1,h2,s1,s2,v1,v2;
        TRect rectpos[256];

        Graphics::TBitmap* buf;

};
//----------------------------------------------------------------------------
extern PACKAGE TColorCustamizeDialog *ColorCustamizeDialog;
//----------------------------------------------------------------------------
#endif    
