#ifndef MainH
#define MainH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>

#include "Tangram.h"
#include "CGAUGES.h"

const int maxhisfiles = 10;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yNX錾z
class TeTeForm : public TForm
{
__published:

        TOpenDialog *OpenDialogPlt;
        TOpenDialog *OpenDialog;
        TSaveDialog *SaveDialog;
        TImageList *ImageList1;
        TStatusBar *StatusBar;
        TComboBox *Copy1PercentageComboBox;
        TComboBox *flipsensComboBox;
        TLabel *Copy1ParcentLabel;
        TLabel *flipsensLabel;
        TCGauge *ProgressBar;

        TActionList *ActionList;
        TAction *FileDirOpen;
        TAction *FileMarge;
        TAction *HisFileOpen;
        TAction *OptActiveViewer;
        TAction *OptmkHTML;
        TAction *OptAA;
        TAction *OptEye;
        TAction *ClipCopy1;
        TAction *ClipCopy2;
        TAction *OptNSortLevel1;
        TAction *OptNSortLevel2;
        TAction *OptNSortLevel3;
        TAction *OptSSort;
        TAction *OptRpcal;
        TAction *FileNew;
        TAction *FileOpen;
        TAction *FileSaveAs;
        TAction *FileSave;
        TAction *FileExit;
        TAction *EditUndo;
        TAction *EditRedo;
        TAction *EditBreak;
        TAction *EditChange;
        TAction *EditAdd;
        TAction *EditDelete;
        TAction *EditDown;
        TAction *EditUp;
        TAction *EditGoEdit;
        TAction *HelpAbout;
        TAction *PaletteCSetBW;
        TAction *PaletteCSetTB;
        TAction *PaletteCSetWB;
        TAction *PaletteCSetBrl;
        TAction *PaletteCSetBrl2;
        TAction *PaletteCSetBrg;
        TAction *PaletteCSetBrR;
        TAction *PaletteColorCustamize;
        TAction *PltSLoad;

        TControlBar *ControlBar1;
        TToolBar *ToolBar;
        TToolButton *ToolButtonNew;
        TToolButton *ToolButtonOpen;
        TToolButton *ToolButtonSave;
        TToolButton *ToolButtonChange;
        TToolBar *OptToolBar;
        TToolButton *ToolButtonCSet;
        TToolButton *ToolButtonOptAA;
        TToolButton *ToolButtonClipCopy1;
        TToolButton *ToolButtonClipCopy2;
        TToolButton *ToolButtonOptEye;

        TToolButton *ToolBarSepalater1;
        TToolButton *ToolBarSepalater2;
        TToolButton *ToolBarSepalater3;
        TToolButton *ToolBarSepalater5;
        TToolButton *ToolBarSepalater6;
        TToolButton *ToolBarSepalater7;

        TMainMenu *MainMenu;
        TMenuItem *File;
        TMenuItem *New;
        TMenuItem *Open;
        TMenuItem *Save;
        TMenuItem *SaveAs;
        TMenuItem *Exit;
        TMenuItem *Edit;
        TMenuItem *Undo;
        TMenuItem *Redo;
        TMenuItem *Break;
        TMenuItem *Add;
        TMenuItem *Delete;
        TMenuItem *GoEdit;
        TMenuItem *Help;
        TMenuItem *About;
        TMenuItem *QRefference;
        TMenuItem *Change;
        TMenuItem *Up;
        TMenuItem *Down;
        TMenuItem *Palette;
        TMenuItem *CSetWB;
        TMenuItem *CSetBW;
        TMenuItem *CSetBrl2;
        TMenuItem *CSetBrg;
        TMenuItem *CSetBrR;
        TMenuItem *CSetBrl;
        TMenuItem *CSetTB;
        TMenuItem *ColorCustamize;
        TPopupMenu *PopupMenuCSet;
        TMenuItem *N2;
        TMenuItem *N3;
        TMenuItem *N4;
        TMenuItem *N5;
        TMenuItem *N6;
        TMenuItem *N7;
        TMenuItem *N8;
        TMenuItem *N9;
        TMenuItem *Opt;
        TMenuItem *NSortLevel1;
        TMenuItem *NSortLevel2;
        TMenuItem *NSortLevel3;
        TMenuItem *NSortMenu;
        TMenuItem *SSort;
        TMenuItem *Rpcal;
        TMenuItem *Marge;
        TMenuItem *Copy1;
        TMenuItem *Copy2;
        TMenuItem *AA;
        TMenuItem *Eye;
        TMenuItem *DirOpen;
        TMenuItem *FileSepalater;
        TMenuItem *EditSepalater1;
        TMenuItem *EditSepalater2;
        TMenuItem *ActiveViewer;
        TMenuItem *OptionSepalater;
        TMenuItem *HTMLH1;
        TScrollBox *ScrollBox1;
        TShape *Shape1;
        TPaintBox *pb2;
        TCheckBox *GuideLock;
        TListBox *List;
        TToolBar *ToolBarList;
        TToolButton *ToolButtonDelete;
        TToolButton *ToolButtonUp;
        TToolButton *ToolButtonDown;
        TToolButton *ToolButtonGoEdit;
        TToolButton *ToolBarListSepalater1;
        TToolButton *ToolButtonShowTable;
        TPopupMenu *PopupMenuPlt;
        TMenuItem *defaultPlt;
        TMenuItem *pltSelectSepalater;
        TPopupMenu *PopupMenuHis;
        TBevel *Bevel1;
        TPaintBox *pb1;
        TShape *Shape2;
        TToolBar *ToolBarEdit;
        TToolButton *ToolButtonAdd;
        TToolButton *ToolButtonUndo;
        TToolButton *ToolButtonRedo;
        TToolButton *ToolBarEditSepalater1;
        TToolButton *ToolButtonBreak;
        TEdit *CaptionInput;

        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall FormPaint(TObject *Sender);

        void __fastcall FileNewExecute(TObject *Sender);
        void __fastcall FileOpenExecute(TObject *Sender);
        void __fastcall FileExitExecute(TObject *Sender);
        void __fastcall FileSaveExecute(TObject *Sender);
        void __fastcall FileSaveAsExecute(TObject *Sender);
        void __fastcall FileMargeExecute(TObject *Sender);
        void __fastcall FileDirOpenExecute(TObject *Sender);

        void __fastcall ListClick(TObject *Sender);
        void __fastcall ListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ListMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall ListDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
        void __fastcall ListEndDrag(TObject *Sender, TObject *Target,
          int X, int Y);
        void __fastcall ListDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);

        void __fastcall EditBreakExecute(TObject *Sender);
        void __fastcall EditGoEditExecute(TObject *Sender);
        void __fastcall EditDeleteExecute(TObject *Sender);
        void __fastcall EditDownExecute(TObject *Sender);
        void __fastcall EditUpExecute(TObject *Sender);
        void __fastcall EditAddExecute(TObject *Sender);
        void __fastcall EditChangeExecute(TObject *Sender);
        void __fastcall EditUndoExecute(TObject *Sender);
        void __fastcall EditRedoExecute(TObject *Sender);
        void __fastcall ToolButtonShowTableClick(TObject *Sender);

        void __fastcall PaletteCSetExecute(TObject *Sender);
        void __fastcall PaletteColorCustamizeExecute(TObject *Sender);
        void __fastcall HelpQRefferenceExecute(TObject *Sender);
        void __fastcall HelpAboutExecute(TObject *Sender);
        void __fastcall PltSLoadExecute(TObject *Sender);
        void __fastcall ClipCopy1Execute(TObject *Sender);
        void __fastcall ClipCopy2Execute(TObject *Sender);
        void __fastcall OptAAExecute(TObject *Sender);
        void __fastcall OptNSortExecute(TObject *Sender);
        void __fastcall OptSSortExecute(TObject *Sender);
        void __fastcall OptRpcalExecute(TObject *Sender);
        void __fastcall OptEyeExecute(TObject *Sender);
        void __fastcall AAClick(TObject *Sender);
        void __fastcall OptActiveViewerExecute(TObject *Sender);
        void __fastcall OptmkHTMLExecute(TObject *Sender);

        void __fastcall CaptionInputChange(TObject *Sender);
        void __fastcall flipsensComboBoxChange(TObject *Sender);
        void __fastcall ToolButtonCSetClick(TObject *Sender);
        void __fastcall Copy1PercentageComboBoxChange(TObject *Sender);
        void __fastcall HisFileOpenExecute(TObject *Sender);
        void __fastcall ToolButtonAddMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);

        void __fastcall pb1MouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
        void __fastcall pb1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall pb1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FormResize(TObject *Sender);



private:
        void    CSet(TColor bgcolor, int r1,int g1,int b1, int r2,int g2,int b2);
        void    PaletteColorCustamizeBody(void);
        void    ResetUndo(void);
        void    PushUndoBank(void);
        void    SetDefault(void);
        void    strPltesExpand(void);
        void    sTod(void);
        void    DrawPcs(int mode);
        void    CalcPoint(int pltnum);
        void    RefleshBank(void);
        void    PushBank(int pltnum);
        void    PopBank(int pltnum);
        void    DrawBar(void);
        void    sToPcs(void);
        void    PcsTos(void);
        void    PcsInit(void);
        void    ViewPcs(void);
        void    DrawTable(void);
        void    SelectTable(void);
        void    NewPcs(int mode);
        TPoint  roll(int x,int y,int w);
        void    NewFile(void);
        bool    NoSaveCheck(bool canselbutton);
        void    EditButtons(void);
        void    mkListNum(int startIdx,int n);
        void    PltLoad(AnsiString pltfname);
        void    StrechClipCopy(int percentage);
        void    ReDraw(bool pb1sw,bool pb2sw);
        void    ShortOfMemory(void);
        void    PushHistory(void);
        void    SetHistory(void);
        bool    numcheck(AnsiString s);

        bool    pngout(AnsiString Filename,Graphics::TBitmap* bmp);

public:
        __fastcall TeTeForm(TComponent* Owner);

        Graphics::TBitmap*      buf1;           //vj
        Graphics::TBitmap*      buf2;           //@V

        Tangram*                Tan;            //@V
        TMenuItem**             pltMenuItem;    //@V
        TStringList*            pltFilename;    //@V
        int                     pltFiles;

        int                     pb1ActLevel;
        TPoint                  startpos,lastpos;
        bool                    RectSelect,RectExists;
        bool                    PointSelect;

        TPoint                  Origin, dOrigin;
        int                     dcx[1024], dcxp;
        int                     dcxn, dcxs, dcxabs;
        int                     dcxsmin;
        int                     dcxabsmax;
        int                     flipsens;
        int                     fssens;

        double                  gamma;

        int                     undoB, undoF, undoPos;
        int                     maxundo;
        TPcs*                   UndoBank;       //@V
        TPcs                    Pcs_, Pcs__, Pcs2;

        AnsiString              OpenFileHistory[maxhisfiles];
        TMenuItem*              HisMenuItem[maxhisfiles];       //@V

        int                     index1, index2;
        int                     ho,hr, so,sr, vo,vr;
        TColor                  bgcolor_;
        int                     ho_,hr_, so_,sr_, vo_,vr_;
        int                     top,left,height,width,state;
        int                     sbx,sby,sbz;

};

extern PACKAGE TeTeForm *eTeForm;

#endif
