//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Rpcal.h"
#include "Main.h"
#include "math.h"

#pragma package(smart_init)
#pragma resource "*.dfm"
TRpcalForm *RpcalForm;
//---------------------------------------------------------------------------
//RXgN^
__fastcall TRpcalForm::TRpcalForm(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
//RTCe[u̍쐬
void __fastcall TRpcalForm::FormCreate(TObject *Sender)
{
  int i;
  float f;

  for(i=0; i<720; i++){
        f=cos(2.*M_PI*i/720.)*512.5;

        ctbl[i]=int(f);
        }

}

//]ϊ
TPoint __fastcall TRpcalForm::roll(int u,int v,int w)
{
        int s,c,x,y;

        if(w<0) {
                w=720-(-w%720);
        } else {
                w=w%720;
        }
        s=ctbl[(w+540)%720];
        c=ctbl[w];
        x=(u*c-v*s)/512;
        y=(u*s+v*c)/512;

	return Point(x,y);
}

//W̌vZ
void __fastcall TRpcalForm::rpcalculationExecute(TObject *Sender)
{
        int i,ini,fin,itv,x,y,ox,oy;
        float dDeg;
        TPoint pos;

        s=Edit2->Text; if(numcheck()) ini=StrToInt(s); else return;
        s=Edit3->Text; if(numcheck()) fin=StrToInt(s); else return;
        s=Edit4->Text; if(numcheck()) itv=abs(StrToInt(s)); else return;
        if(itv < 2) itv=2;

        s=Edit5->Text; if(numcheck()) ox=StrToInt(s); else return;
        s=Edit6->Text; if(numcheck()) oy=StrToInt(s); else return;
        s=Edit7->Text; if(numcheck()) x=StrToInt(s); else return;
        s=Edit8->Text; if(numcheck()) y=StrToInt(s); else return;


        s="";
        for(i=0; i<itv; i++){

                dDeg = (float)i/(float)(itv-1);
                dDeg = (float)ini*2.*(1-dDeg)+(float)fin*2.*dDeg;
                pos=roll(x,y,int(dDeg));
                s=s+IntToStr(ox+pos.x)+","+IntToStr(oy+pos.y)+", ";

        }

        Edit1->Text = s;


}

//sǂ
bool TRpcalForm::numcheck(void)
{
        int i,i_ = 0;

        if(s.Length() == 0) return false;
        if(s.c_str()[0] == 0x002d){
                if(s.Length() == 1) return false;
                i_ = 1;
        }

        for( i=i_; i<s.Length(); i++ ){
                if((s.c_str()[i] < 0x0030) || (s.c_str()[i] > 0x0039))
                        return false;
        }
        return true;

}

//---------------------------------------------------------------------------

